package com.platform.controller;

import com.platform.annotation.CanUserUpdateRecord;
import com.platform.entity.AddressEntity;
import com.platform.entity.Result;
import com.platform.service.AddressService;
import com.platform.utils.PageUtils;
import com.platform.utils.Query;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * Controller
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-08-16 17:22:46
 */
@RestController
@RequestMapping("address")
public class AddressController {
    @Autowired
    private AddressService addressService;

    /**
     * 查看列表
     */
    @RequestMapping("/list")
    public Result list(@RequestBody Map<String, Object> params) {
        //查询列表数据
        Query query = new Query(params);

        List<AddressEntity> addressList = addressService.queryList(query);
        int total = addressService.queryTotal(query);

        PageUtils pageUtil = new PageUtils(addressList, total, query.getLimit(), query.getPage());

        return Result.success(pageUtil);
    }


    /**
     * 查看信息
     */
    @RequestMapping("/info")

    public Result info(@RequestParam("id") Integer id) {
        AddressEntity address = addressService.queryObject(id);

        return Result.success( address);
    }

    /**
     * 保存
     */
    @CanUserUpdateRecord
    @RequestMapping("/save")

    public Result save(@RequestBody AddressEntity address) {
        addressService.save(address);

        return Result.success();
    }

    /**
     * 修改
     */
    @CanUserUpdateRecord
    @RequestMapping("/update")

    public Result update(@RequestBody AddressEntity address) {
        addressService.update(address);

        return Result.success();
    }

    /**
     * 删除
     */
    @CanUserUpdateRecord
    @RequestMapping("/delete")

    public Result delete(@RequestBody Integer[] ids) {
        addressService.deleteBatch(ids);

        return Result.success();
    }
}
